/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["jquery.sap.global"],function($){"use strict";var a={parse:function(t){if($.type(t)!=="string"){throw new Error("simpleGherkinParser.parse: parameter 'sText' must be a valid string");}var l=t.split("\n").map(function(s){return s.replace(/^\s*#.*/,"").trim();});var f=null,S=null,o=null,T=[],F=[],b=[];for(var i=0;i<l.length;++i){var L=l[i];var c=!!L.match(/^(?:@\w+)(?:\s+@\w+)*$/);if(c){T=L.split(/\s+/);continue;}var d=L.match(/^Feature:(.+)$/);if(d){F=T;f={tags:F,name:d[1].trim(),scenarios:[]};T=[];continue;}var B=!!L.match(/^Background:/);if(B){S=f.background={name:"<background>",steps:[]};continue;}var e=L.match(/^Scenario:(.+)/)||L.match(/^Scenario Outline:(.+)/);if(e){b=F.concat(T);S={tags:b,name:e[1].trim(),steps:[]};f.scenarios.push(S);T=[];continue;}var g=L.match(/^(Given|When|Then|And|But|\*)\s+(.+)$/);if(g){o={text:g[2].trim(),keyword:g[1].trim()};S.steps.push(o);continue;}var E=!!L.match(/^Examples:/);if(E){S.examples=[];continue;}var r=L.match(/^\|(.*)\|$/);if(r){var D=r[1].split("|").map(function(s){return s.trim();});if(D.length===1){D=D[0];}if(S.examples){S.examples.push(D);continue;}o.data=o.data||[];o.data.push(D);}}f.scenarios.forEach(function(S){S.steps.forEach(function(o){if($.isArray(o.data)&&(o.data.length===1)&&($.type(o.data[0])==="array")){o.data=o.data[0];}});});return f;},parseFile:function(p){if($.type(p)!=="string"){throw new Error("simpleGherkinParser.parseFile: parameter 'sPath' must be a valid string");}p=$.sap.getModulePath(p,".feature");var r=$.sap.sjax({url:p,dataType:"text"});if(!r.success){throw new Error("simpleGherkinParser.parseFile: error loading URL: "+p);}return this.parse(r.data);}};return a;},true);
